#!/bin/bash
# This file is in the public domain.

THIS_FILE=$(realpath "$0")
DIR=$(dirname "$THIS_FILE")

# this script requires from debian packages
# * jq 
# * sponge (from moreutils) 
# * wkhtmltopdf
# * qrencode
# * sponge: 
#
# and from python pip packages
#
# * chevron

DATA=$(mktemp)
set -e

[ -z "$1" ] && echo First parameter must be the json file result from \'taler-harness deployment provision-bank-and-merchant\'. Alternative \'-\' can be used if the file is provided from stdin. && exit 1

cat $1 > $DATA

[ -z "$(jq -r '.bankUser//empty' $DATA)" ] && echo the json file is not complete: missing bankUser && exit 1
[ -z "$(jq -r '.bankURL//empty' $DATA)" ] && echo the json file is not complete: missing bankURL && exit 1
[ -z "$(jq -r '.merchantURL//empty' $DATA)" ] && echo the json file is not complete: missing merchantURL && exit 1
[ -z "$(jq -r '.templateURI//empty' $DATA)" ] && echo the json file is not complete: missing templateURI && exit 1
[ -z "$(jq -r '.password//empty' $DATA)" ] && echo the json file is not complete: missing password && exit 1

add_qr_image(){
  jq -r $1 $DATA | qrencode -l Q -m 2 -s 5 -o - | base64 -w 0 | jq -Rn '{"'$2'":inputs}' | jq -s add - $DATA | sponge $DATA
}

add_qr_image .templateURI templateQR
add_qr_image .bankURL bankQR
add_qr_image .merchantURL merchantQR

chevron $DIR/pdf-template.html -d $DATA | wkhtmltopdf - out.pdf

